Subject: bug#47717: guix outrageously exhaust itself (freeze) when there is package build failure

From: raingloom <[email-masked]>
Date: Tue, 13 Apr 2021 00:59:34 +0200

On Mon, 12 Apr 2021 20:41:00 +0200
Tobias Geerinckx-Rice via Bug reports for GNU Guix <[email-masked]>
wrote:

> Hi bo0od,
> 
> Your subject was quite dramatic and probably not true.  Try to 
> avoid both.
> 
> bo0od writes:
> > The real issue it caused guix to freeze for like not less than 
> > 2+
> > hours and i couldnt do anything with the distro until guix cut 
> > out
> > the build/upgradation by itself.  
> 
> Take a look at (and next time, attach)
> 
>   $ bzless 
>   /var/log/guix/drvs/5a/8xxi15g20iqr78daw3w1c7xyqmmd1k-vigra-1.11.1.drv.bz2
> 
> the log file mentioned in the error message.  You'll probably find 
> the string ‘Killed’ near the end.  If you haven't rebooted yet,
> 
>   $ grep oom /proc/vmstat
> 
> will probably return something non-zero.
> 
> If so: you ran out of memory while building a heavy package.  This 
> causes your system to become unresponsive whilst it tries to 
> postpone that for as long as possible.  This is a fact of Linux.
> 
> You can try to work around it by adding RAM, passing ‘-{M,c}1’ to 
> the guix command that failed, and/or enabling swap, but the root 
> cause is you simply don't have enough memory to build this package 
> at its default settings.
> 
> Or, you can make sure you download a substitute instead of trying 
> to build everything locally.  At the time of writing (commit 
> d14f213) there's a libreoffice substitute on ci.guix.gnu.org.  Are 
> substitutes configured and enabled?
> 
> Kind regards,
> 
> T G-R

Also this is an issue in general with the Linux OOM killer. I recommend
installing earlyoom. It's already packaged in Guix and there is even a
service description for it.
It will help with the freezing issue.